InitSprite()
InitSprite3D()
InitKeyboard()

Procedure.f min(a.f, d.f)
  If a < d
    ProcedureReturn a
  Else
    ProcedureReturn d
  EndIf
EndProcedure

Procedure.f max(a.f, d.f)
  If a > d
    ProcedureReturn a
  Else
    ProcedureReturn d
  EndIf
EndProcedure

Procedure.f sign(a.f)
  If a.f < 0
    ProcedureReturn -1.0
  Else
    ProcedureReturn 1.0
  EndIf
EndProcedure

Quit.b = #False

DRAG.f = 5.0
RESISTANCE.f = 30.0
CA_R.f = -5.20
CA_F.f = 2.0
MAX_GRIP.f = 2.0
delta_t.f = 0.1

x.f = 320
y.f = 240

; INIT
b.f = 1.0
c.f = 1.0
wheelbase.f = b + c
h.f = 1.0
mass.f = 1500
inertia.f = 1500
lenght.f = 3.0
width.f = 1.5
wheellenght.f = 0.7
wheelwidth.f = 0.3

; Struct CAR
position_wc_x.f = x
position_wc_y.f = y

velocity_wc_x.f = 0.0 
velocity_wc_y.f = 0.0

angle.f = 0.0
angularvelocity.f = 0.0
steerangle.f = 0.0

throttle.f = 0.0
brake.f = 0.0

; Lots of globals
velocity_x.f = 0.0
velocity_y.f = 0.0

rot_angle.f = 0.0

sideslip.f = 0.0
slipanglefront.f = 0.0
slipanglerear.f = 0.0

force_x.f = 0.0
force_y.f = 0.0

rear_slip = 0
front_slip = 0

resistance_x.f = 0.0
resistance_y.f = 0.0

torque.f = 0.0
angular_acceleration.f = 0.0

sn.f = 0.0
cs.f = 0.0

yawspeed.f = 0.0
weight.f = 0.0

ftraction_x.f = 0.0
ftraction_y.f = 0.0

flatf_x.f = 0.0
flatf_y.f = 0.0

flatr_x.f = 0.0
flatr_y.f = 0.0


If OpenWindow(0, 0, 0, 640, 480, "Car Physics", #PB_Window_ScreenCentered|#PB_Window_SystemMenu)
  OpenWindowedScreen(WindowID(0), 0, 0, 640, 480, 0, 0, 0)
  
  LoadSprite(0, "car.bmp", #PB_Sprite_Texture)
  CreateSprite3D(0, 0)
  
  Repeat
    
    WEvent = WindowEvent()
    
    If WEvent = #PB_Event_CloseWindow
      Quit = #True    
    EndIf

    ExamineKeyboard()
    

    If KeyboardPushed(#PB_Key_Up)
      If  throttle < 100
        throttle + 10
      EndIf
    ElseIf KeyboardPushed(#PB_Key_Down)
      If throttle >= 10
        throttle - 10
      EndIf
    Else
      If throttle < 0
        throttle + 10
      ElseIf throttle > 0
        throttle - 10
      EndIf
    EndIf
    
    If KeyboardPushed(#PB_Key_LeftControl)
      brake = 100
      throttle = 0
    Else
      brake = 0
    EndIf
    
    If KeyboardPushed(#PB_Key_Left)
      If steerangle > -#PI / 4.0
        steerangle - (#PI / 32.0)
      EndIf
    ElseIf KeyboardPushed(#PB_Key_Right)
      If steerangle < #PI / 4.0
        steerangle + (#PI / 32.0)
      EndIf
    Else
      If steerangle > 0
        steerangle - (#PI / 40.0)
      ElseIf steerangle < 0
        steerangle + (#PI / 40.0)
      EndIf
      If Abs(steerangle) < (#PI / 40.0)
        steerangle = 0
      EndIf
    EndIf


    ; STEP
    sn = Sin(angle)
    cs = Cos(angle)
    
    velocity_x = cs * velocity_wc_y + sn * velocity_wc_x
    velocity_y = -sn * velocity_wc_y + cs * velocity_wc_x
    
    yawspeed = wheelbase * 0.5 * angularvelocity
    
    If velocity_x=0
       rot_angle = 0
    Else
      rot_angle = ATan(yawspeed / velocity_x)
    EndIf
      
    If velocity_x=0
      sideslip = 0
    Else
      sideslip = ATan(velocity_y / velocity_x)
    EndIf
    
    
    slipanglefront = sideslip + rot_angle-steerangle
    slipanglerear = sideslip - rot_angle
    
    weight = mass * 9.8 * 0.5
    
    flatf_x = 0
    flatf_y = CA_F*slipanglefront
    flatf_y = min(MAX_GRIP,flatf_y)
    flatf_y = max(-MAX_GRIP,flatf_y)
    flatf_y = flatf_y * weight
    
    If front_slip = 1
      flatf_y = flatf_y* 0.5
    EndIf
    
    flatr_x = 0;
    flatr_y = CA_R*slipanglerear
    flatr_y = min(MAX_GRIP,flatr_y)
    flatr_y = max(-MAX_GRIP,flatr_y)
    flatr_y = flatr_y * weight
    
    If rear_slip = 1
      flatr_y = flatr_y* 0.5
    EndIf  
    
    ftraction_x = 100*(throttle-brake*sign(velocity_x))
    ftraction_y = 0
    
    If rear_slip = 1
      ftraction_x = ftraction_x * 0.5
    EndIf
    
    resistance_x = -(RESISTANCE*velocity_x + DRAG*velocity_x*Abs(velocity_x))
    resistance_y = -(RESISTANCE*velocity_y + DRAG*velocity_y*Abs(velocity_y))
    
    force_x = ftraction_x + Sin(steerangle)*flatf_x + flatr_x + resistance_x
    force_y = ftraction_y + Cos(steerangle)*flatf_y + flatr_y + resistance_y
    
    torque = (b * flatf_y) - (c * flatr_y)
    
    acceleration_x.f = force_x/mass
    acceleration_y.f = force_y/mass
    
    angular_acceleration = torque/inertia
    
    acceleration_wc_x.f = cs*acceleration_y + sn*acceleration_x
    acceleration_wc_y.f = -sn*acceleration_y + cs*acceleration_x
    
    velocity_wc_x + (delta_t*acceleration_wc_x)
    velocity_wc_y + (delta_t*acceleration_wc_y)
    
    position_wc_x + (delta_t*velocity_wc_x)
    position_wc_y + (delta_t*velocity_wc_y)
    
    angularvelocity + (delta_t*angular_acceleration)
    angle + (delta_t*angularvelocity)
    
    x = position_wc_x
    y = position_wc_y    
    
    direction = Round(angle * 180 / #PI, 0)
    
    StartDrawing(ScreenOutput())
    DrawText(0, 0, "Car x: " + StrF(x))
    DrawText(0, 20, "Car y: " + StrF(y))
    DrawText(0, 40, "Car Angle: "+ StrF(direction))
    DrawText(0, 60, "Throttle: "+ StrF(throttle))
    DrawText(0, 80, "Steerangle: " + StrF(steerangle))
    DrawText(0, 100, "Torque: " + StrF(torque));
    DrawText(0, 120, "Flat Front Yaw: " + StrF(flatf_y))
    DrawText(0, 140, "Flat Rear Yaw: " + StrF(flatr_y))
    DrawText(0, 160, "Force Y: " + StrF(force_y))
    StopDrawing()
    
    Start3D()
    RotateSprite3D(0, -direction, 0)
    DisplaySprite3D(0, x, y, 255)
    Stop3D()
    
    FlipBuffers()
    ClearScreen(0)
    Delay(10)
    
  Until Quit = #True
  
  CloseWindow(0)
EndIf
; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 120
; FirstLine = 110
; Folding = -